apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ .Release.Name }}
spec:
  replicas: 1
  strategy:
    type: RollingUpdate
    rollingUpdate:
      maxSurge: 1
      maxUnavailable: 0
  selector:
    matchLabels:
      app.kubernetes.io/component: okd-api-sso-token-exchange
      app.kubernetes.io/name: {{ .Release.Name }}
      app.kubernetes.io/instance: {{ .Release.Name }}
  template:
    metadata:
      name: {{ .Release.Name }}
      labels:
        app.kubernetes.io/component: okd-api-sso-token-exchange
        app.kubernetes.io/name: {{ .Release.Name }}
        app.kubernetes.io/instance: {{ .Release.Name }}
    spec:
      serviceAccountName: {{ .Release.Name }}
      {{- if .Values.nodeSelector }}
      nodeSelector: {{ .Values.nodeSelector | toYaml | nindent 8 }}
      {{- end }}
      {{- if .Values.tolerations }}
      tolerations: {{ .Values.tolerations | toYaml | nindent 8 }}
      {{- end }}
      containers:
        - name: okd-api-sso-token-exchange
          image: {{ .Values.image }}
          imagePullPolicy: {{ .Values.imagePullPolicy }}
          args:
          - -audience={{ .Values.targetAudience }}
          - -token-expires-in={{ .Values.tokenExpiresIn }}
          - -jwks-url={{ .Values.jwksURL }}
          - -client-name={{ .Values.clientName }}
          ports:
            - name: http
              containerPort: 8080
              protocol: TCP
          {{- if .Values.resources }}
          resources: {{ .Values.resources | toYaml | nindent 12}}
          {{- end }}
          readinessProbe:
            httpGet:
              port: 8080
              path: /ping
            initialDelaySeconds: 3
            failureThreshold: 2
            successThreshold: 3
            timeoutSeconds: 5
            periodSeconds: 10
          livenessProbe:
            httpGet:
              port: 8080
              path: /ping
            initialDelaySeconds: 30
            failureThreshold: 3
            successThreshold: 1
            timeoutSeconds: 5
            periodSeconds: 30
      restartPolicy: Always
